<html>
<head>
<title>OGRE: Ogre::ConvexBody Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a></div>
<h1>Ogre::ConvexBody Class Reference</h1><!-- doxytag: class="Ogre::ConvexBody" -->Holds a solid representation of a convex body.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1ConvexBody-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1Polygon.html">Polygon</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#4a13eb065fe856b0354d523394e9dfaa">PolygonList</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#55e376da89733093d9061f2b5acebfb2">ConvexBody</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#6f643f10031458c33cc9b51dc4a8f893">~ConvexBody</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#e9792f9784f57a75d89a8aecb9ee2f58">ConvexBody</a> (const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;cpy)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#9abd096ec64a6eedbd942a4f15ae4c34">define</a> (const <a class="el" href="classOgre_1_1Frustum.html">Frustum</a> &amp;frustum)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Build a new polygon representation from a frustum.  <a href="#9abd096ec64a6eedbd942a4f15ae4c34"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#f344427771b8ee0bde94a04e68cf4b77">define</a> (const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;aab)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Build a new polygon representation from an AAB.  <a href="#f344427771b8ee0bde94a04e68cf4b77"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#f5fb91ac168eec8056adb7b2677523e1">clip</a> (const <a class="el" href="classOgre_1_1Frustum.html">Frustum</a> &amp;frustum)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clips the body with a frustum.  <a href="#f5fb91ac168eec8056adb7b2677523e1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#d414f1e05c49050f464c164b9da8e04d">clip</a> (const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;aab)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clips the body with an AAB.  <a href="#d414f1e05c49050f464c164b9da8e04d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#132ccd23a0b43b15077605d813051c4d">clip</a> (const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;body)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clips the body with another body.  <a href="#132ccd23a0b43b15077605d813051c4d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#c8a3f100f1b91cadf03ec2b9d9d6f684">clip</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;pl, bool keepNegative=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clips the object by the positive half space of a plane.  <a href="#c8a3f100f1b91cadf03ec2b9d9d6f684"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#b281318edcb6f9438693caecf718616c">extend</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;pt)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extends the existing body to incorporate the passed in point as a convex hull.  <a href="#b281318edcb6f9438693caecf718616c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#153a0fac3f0c9687a969a2565ccd320e">reset</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Resets the object.  <a href="#153a0fac3f0c9687a969a2565ccd320e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#b31e6599524de129c8186db52f4d3bfc">getPolygonCount</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the current number of polygons.  <a href="#b31e6599524de129c8186db52f4d3bfc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#b62abaefae0a1d6352a05f4945bee81f">getVertexCount</a> (size_t poly) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the number of vertices for a polygon.  <a href="#b62abaefae0a1d6352a05f4945bee81f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1Polygon.html">Polygon</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#6a3e37ac14a7f02de3cf214a3c6eac11">getPolygon</a> (size_t poly) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a polygon.  <a href="#6a3e37ac14a7f02de3cf214a3c6eac11"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#e941be51c7c3b852c67e51a15c0bb757">getVertex</a> (size_t poly, size_t vertex) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a specific vertex of a polygon.  <a href="#e941be51c7c3b852c67e51a15c0bb757"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#bc9d10d37f23d0a0b82f1773bac04e1e">getNormal</a> (size_t poly)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the normal of a specified polygon.  <a href="#bc9d10d37f23d0a0b82f1773bac04e1e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#83072f016eefa58aeb053131faf48ec5">getAABB</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns an AABB representation.  <a href="#83072f016eefa58aeb053131faf48ec5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#6d364974ae7837fb6d733b973a8c2e23">hasClosedHull</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Checks if the body has a closed hull.  <a href="#6d364974ae7837fb6d733b973a8c2e23"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#4d33db4b9003a76a299649cede0c5557">mergePolygons</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Merges all neighboring polygons into one single polygon if they are lay in the same plane.  <a href="#4d33db4b9003a76a299649cede0c5557"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#d671d14101224807f28de10abf66f8cd">operator==</a> (const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;rhs) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Determines if the current object is equal to the compared one.  <a href="#d671d14101224807f28de10abf66f8cd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#54167fd6c91338d1d107fa866c329a3b">operator!=</a> (const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;rhs) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Determines if the current object is not equal to the compared one.  <a href="#54167fd6c91338d1d107fa866c329a3b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#6244600b134c90e33fa32e6d0f1e008b">logInfo</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="classOgre_1_1Log.html" title="Log class for writing debug/log data to files.">Log</a> details of this body.  <a href="#6244600b134c90e33fa32e6d0f1e008b"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#59fb24ee9a509ade6490ad1d9aac16d7">_initialisePool</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialise the internal polygon pool used to minimise allocations.  <a href="#59fb24ee9a509ade6490ad1d9aac16d7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#0858a878ce677241ef5632b04a7ffea4">_destroyPool</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tear down the internal polygon pool used to minimise allocations.  <a href="#0858a878ce677241ef5632b04a7ffea4"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#975d3ab5e37339fac99d712a32134b71">insertPolygon</a> (<a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *pdata, size_t poly)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Inserts a polygon at a partcular point in the body.  <a href="#975d3ab5e37339fac99d712a32134b71"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#6d15ea1ce9f9249484b178bb209b2b95">insertPolygon</a> (<a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *pdata)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Inserts a polygon at the end.  <a href="#6d15ea1ce9f9249484b178bb209b2b95"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#9d5648f1dd2ab1dd9c85b1581029983e">insertVertex</a> (size_t poly, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vdata, size_t vertex)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Inserts a vertex for a polygon at a particular point.  <a href="#9d5648f1dd2ab1dd9c85b1581029983e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#1e4e72b739b38002b714bcbb63813a7d">insertVertex</a> (size_t poly, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vdata)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Inserts a vertex for a polygon at the end.  <a href="#1e4e72b739b38002b714bcbb63813a7d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#96f5b0fff03173772d7e20e5ec74e237">deletePolygon</a> (size_t poly)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Deletes a specific polygon.  <a href="#96f5b0fff03173772d7e20e5ec74e237"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#bd7e84750f61aed920fb4e847ea29ac9">unlinkPolygon</a> (size_t poly)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes a specific polygon from the body without deleting it.  <a href="#bd7e84750f61aed920fb4e847ea29ac9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#d139be0d8377d805b0709966974a5cda">moveDataFromBody</a> (<a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;body)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Moves all polygons from the parameter body to this instance.  <a href="#d139be0d8377d805b0709966974a5cda"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#803fa40122153f8772383b7d79ec7e6a">deleteVertex</a> (size_t poly, size_t vertex)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Deletes a specific vertex of a specific polygon.  <a href="#803fa40122153f8772383b7d79ec7e6a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#28a76d44fefb5741e2c772533f7b1ed0">setPolygon</a> (<a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *pdata, size_t poly)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Replace a polygon at a particular index.  <a href="#28a76d44fefb5741e2c772533f7b1ed0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#115357323021c86327c0aa8a26b2404f">setVertex</a> (size_t poly, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vdata, size_t vertex)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Replace a specific vertex of a polygon.  <a href="#115357323021c86327c0aa8a26b2404f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">Polygon::EdgeMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#fb0f28d2bc33d000f2b924b3ff287984">getSingleEdges</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the single edges in an EdgeMap (= edges where one side is a vertex and the other is empty space (a hole in the body)).  <a href="#fb0f28d2bc33d000f2b924b3ff287984"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#4bd6ead8c709b50e3ae96e6c518b50cc">storeEdgesOfPolygon</a> (size_t poly, <a class="el" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">Polygon::EdgeMap</a> *edgeMap) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Stores the edges of a specific polygon in a passed in structure.  <a href="#4bd6ead8c709b50e3ae96e6c518b50cc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#712d479b37a37cf294f249b942546293">allocateSpace</a> (size_t numPolygons, size_t numVertices)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocates space for an specified amount of polygons with each of them having a specified number of vertices.  <a href="#712d479b37a37cf294f249b942546293"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#d9638a611986e5d9fbafacd777bb7bd3">findAndEraseEdgePair</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vec, <a class="el" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">Polygon::EdgeMap</a> &amp;intersectionEdges, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vNext) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Searches for a pair (an edge) in the intersectionList with an entry that equals vec, and removes it from the passed in list.  <a href="#d9638a611986e5d9fbafacd777bb7bd3"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#e7eb606d204e881ac3620f49ef252e7c">allocatePolygon</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a new polygon from the pool.  <a href="#e7eb606d204e881ac3620f49ef252e7c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#168b8dd909571bb3f45480d21e709fd4">freePolygon</a> (<a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *poly)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Release a polygon back tot he pool.  <a href="#168b8dd909571bb3f45480d21e709fd4"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ConvexBody.html#4a13eb065fe856b0354d523394e9dfaa">PolygonList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#4a9287e8e6a68839a451150959b1cd95">mPolygons</a></td></tr>

<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1ConvexBody.html#4a13eb065fe856b0354d523394e9dfaa">PolygonList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#8f45e2762a61cfa1ce2cf11fbc8cb6a9">msFreePolygons</a></td></tr>

<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">_OgreExport friend <br>
std::ostream &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ConvexBody.html#1082989fe2c9773d3e2385dec3f7f694">operator&lt;&lt;</a> (std::ostream &amp;strm, const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;body)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Prints out the body with all its polygons.  <a href="#1082989fe2c9773d3e2385dec3f7f694"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Holds a solid representation of a convex body. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Administers a convex body. All polygons of the body are convex and planar. Several operations may be applied, ranging from intersection to join where each result it itself a convex body. </dd></dl>

<p>Definition at line <a class="el" href="OgreConvexBody_8h-source.html#l00046">46</a> of file <a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="4a13eb065fe856b0354d523394e9dfaa"></a><!-- doxytag: member="Ogre::ConvexBody::PolygonList" ref="4a13eb065fe856b0354d523394e9dfaa" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt; <a class="el" href="classOgre_1_1Polygon.html">Polygon</a>* &gt; <a class="el" href="classOgre_1_1ConvexBody.html#4a13eb065fe856b0354d523394e9dfaa">Ogre::ConvexBody::PolygonList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreConvexBody_8h-source.html#l00049">49</a> of file <a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="55e376da89733093d9061f2b5acebfb2"></a><!-- doxytag: member="Ogre::ConvexBody::ConvexBody" ref="55e376da89733093d9061f2b5acebfb2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ConvexBody::ConvexBody           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="6f643f10031458c33cc9b51dc4a8f893"></a><!-- doxytag: member="Ogre::ConvexBody::~ConvexBody" ref="6f643f10031458c33cc9b51dc4a8f893" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ConvexBody::~ConvexBody           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="e9792f9784f57a75d89a8aecb9ee2f58"></a><!-- doxytag: member="Ogre::ConvexBody::ConvexBody" ref="e9792f9784f57a75d89a8aecb9ee2f58" args="(const ConvexBody &amp;cpy)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ConvexBody::ConvexBody           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cpy</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="9abd096ec64a6eedbd942a4f15ae4c34"></a><!-- doxytag: member="Ogre::ConvexBody::define" ref="9abd096ec64a6eedbd942a4f15ae4c34" args="(const Frustum &amp;frustum)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::define           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Frustum.html">Frustum</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>frustum</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Build a new polygon representation from a frustum. 
<p>

</div>
</div><p>
<a class="anchor" name="f344427771b8ee0bde94a04e68cf4b77"></a><!-- doxytag: member="Ogre::ConvexBody::define" ref="f344427771b8ee0bde94a04e68cf4b77" args="(const AxisAlignedBox &amp;aab)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::define           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>aab</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Build a new polygon representation from an AAB. 
<p>

</div>
</div><p>
<a class="anchor" name="f5fb91ac168eec8056adb7b2677523e1"></a><!-- doxytag: member="Ogre::ConvexBody::clip" ref="f5fb91ac168eec8056adb7b2677523e1" args="(const Frustum &amp;frustum)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::clip           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Frustum.html">Frustum</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>frustum</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clips the body with a frustum. 
<p>
The resulting holes are filled with new polygons. 
</div>
</div><p>
<a class="anchor" name="d414f1e05c49050f464c164b9da8e04d"></a><!-- doxytag: member="Ogre::ConvexBody::clip" ref="d414f1e05c49050f464c164b9da8e04d" args="(const AxisAlignedBox &amp;aab)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::clip           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>aab</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clips the body with an AAB. 
<p>
The resulting holes are filled with new polygons. 
</div>
</div><p>
<a class="anchor" name="132ccd23a0b43b15077605d813051c4d"></a><!-- doxytag: member="Ogre::ConvexBody::clip" ref="132ccd23a0b43b15077605d813051c4d" args="(const ConvexBody &amp;body)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::clip           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>body</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clips the body with another body. 
<p>

</div>
</div><p>
<a class="anchor" name="c8a3f100f1b91cadf03ec2b9d9d6f684"></a><!-- doxytag: member="Ogre::ConvexBody::clip" ref="c8a3f100f1b91cadf03ec2b9d9d6f684" args="(const Plane &amp;pl, bool keepNegative=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::clip           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>pl</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>keepNegative</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clips the object by the positive half space of a plane. 
<p>

</div>
</div><p>
<a class="anchor" name="b281318edcb6f9438693caecf718616c"></a><!-- doxytag: member="Ogre::ConvexBody::extend" ref="b281318edcb6f9438693caecf718616c" args="(const Vector3 &amp;pt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::extend           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>pt</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Extends the existing body to incorporate the passed in point as a convex hull. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You must already have constructed a basic body using a 'construct' method. </dd></dl>

</div>
</div><p>
<a class="anchor" name="153a0fac3f0c9687a969a2565ccd320e"></a><!-- doxytag: member="Ogre::ConvexBody::reset" ref="153a0fac3f0c9687a969a2565ccd320e" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::reset           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Resets the object. 
<p>

</div>
</div><p>
<a class="anchor" name="b31e6599524de129c8186db52f4d3bfc"></a><!-- doxytag: member="Ogre::ConvexBody::getPolygonCount" ref="b31e6599524de129c8186db52f4d3bfc" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::ConvexBody::getPolygonCount           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the current number of polygons. 
<p>

</div>
</div><p>
<a class="anchor" name="b62abaefae0a1d6352a05f4945bee81f"></a><!-- doxytag: member="Ogre::ConvexBody::getVertexCount" ref="b62abaefae0a1d6352a05f4945bee81f" args="(size_t poly) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::ConvexBody::getVertexCount           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the number of vertices for a polygon. 
<p>

</div>
</div><p>
<a class="anchor" name="6a3e37ac14a7f02de3cf214a3c6eac11"></a><!-- doxytag: member="Ogre::ConvexBody::getPolygon" ref="6a3e37ac14a7f02de3cf214a3c6eac11" args="(size_t poly) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Polygon.html">Polygon</a>&amp; Ogre::ConvexBody::getPolygon           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a polygon. 
<p>

</div>
</div><p>
<a class="anchor" name="e941be51c7c3b852c67e51a15c0bb757"></a><!-- doxytag: member="Ogre::ConvexBody::getVertex" ref="e941be51c7c3b852c67e51a15c0bb757" args="(size_t poly, size_t vertex) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&amp; Ogre::ConvexBody::getVertex           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertex</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a specific vertex of a polygon. 
<p>

</div>
</div><p>
<a class="anchor" name="bc9d10d37f23d0a0b82f1773bac04e1e"></a><!-- doxytag: member="Ogre::ConvexBody::getNormal" ref="bc9d10d37f23d0a0b82f1773bac04e1e" args="(size_t poly)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&amp; Ogre::ConvexBody::getNormal           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the normal of a specified polygon. 
<p>

</div>
</div><p>
<a class="anchor" name="83072f016eefa58aeb053131faf48ec5"></a><!-- doxytag: member="Ogre::ConvexBody::getAABB" ref="83072f016eefa58aeb053131faf48ec5" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> Ogre::ConvexBody::getAABB           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns an AABB representation. 
<p>

</div>
</div><p>
<a class="anchor" name="6d364974ae7837fb6d733b973a8c2e23"></a><!-- doxytag: member="Ogre::ConvexBody::hasClosedHull" ref="6d364974ae7837fb6d733b973a8c2e23" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::ConvexBody::hasClosedHull           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Checks if the body has a closed hull. 
<p>

</div>
</div><p>
<a class="anchor" name="4d33db4b9003a76a299649cede0c5557"></a><!-- doxytag: member="Ogre::ConvexBody::mergePolygons" ref="4d33db4b9003a76a299649cede0c5557" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::mergePolygons           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Merges all neighboring polygons into one single polygon if they are lay in the same plane. 
<p>

</div>
</div><p>
<a class="anchor" name="d671d14101224807f28de10abf66f8cd"></a><!-- doxytag: member="Ogre::ConvexBody::operator==" ref="d671d14101224807f28de10abf66f8cd" args="(const ConvexBody &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::ConvexBody::operator==           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Determines if the current object is equal to the compared one. 
<p>

</div>
</div><p>
<a class="anchor" name="54167fd6c91338d1d107fa866c329a3b"></a><!-- doxytag: member="Ogre::ConvexBody::operator!=" ref="54167fd6c91338d1d107fa866c329a3b" args="(const ConvexBody &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::ConvexBody::operator!=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Determines if the current object is not equal to the compared one. 
<p>

<p>Definition at line <a class="el" href="OgreConvexBody_8h-source.html#l00142">142</a> of file <a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="6244600b134c90e33fa32e6d0f1e008b"></a><!-- doxytag: member="Ogre::ConvexBody::logInfo" ref="6244600b134c90e33fa32e6d0f1e008b" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::logInfo           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<a class="el" href="classOgre_1_1Log.html" title="Log class for writing debug/log data to files.">Log</a> details of this body. 
<p>

</div>
</div><p>
<a class="anchor" name="59fb24ee9a509ade6490ad1d9aac16d7"></a><!-- doxytag: member="Ogre::ConvexBody::_initialisePool" ref="59fb24ee9a509ade6490ad1d9aac16d7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::ConvexBody::_initialisePool           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialise the internal polygon pool used to minimise allocations. 
<p>

</div>
</div><p>
<a class="anchor" name="0858a878ce677241ef5632b04a7ffea4"></a><!-- doxytag: member="Ogre::ConvexBody::_destroyPool" ref="0858a878ce677241ef5632b04a7ffea4" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::ConvexBody::_destroyPool           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Tear down the internal polygon pool used to minimise allocations. 
<p>

</div>
</div><p>
<a class="anchor" name="e7eb606d204e881ac3620f49ef252e7c"></a><!-- doxytag: member="Ogre::ConvexBody::allocatePolygon" ref="e7eb606d204e881ac3620f49ef252e7c" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Polygon.html">Polygon</a>* Ogre::ConvexBody::allocatePolygon           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get a new polygon from the pool. 
<p>

</div>
</div><p>
<a class="anchor" name="168b8dd909571bb3f45480d21e709fd4"></a><!-- doxytag: member="Ogre::ConvexBody::freePolygon" ref="168b8dd909571bb3f45480d21e709fd4" args="(Polygon *poly)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::ConvexBody::freePolygon           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *&nbsp;</td>
          <td class="paramname"> <em>poly</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Release a polygon back tot he pool. 
<p>

</div>
</div><p>
<a class="anchor" name="975d3ab5e37339fac99d712a32134b71"></a><!-- doxytag: member="Ogre::ConvexBody::insertPolygon" ref="975d3ab5e37339fac99d712a32134b71" args="(Polygon *pdata, size_t poly)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::insertPolygon           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *&nbsp;</td>
          <td class="paramname"> <em>pdata</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Inserts a polygon at a partcular point in the body. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>After this method is called, the <a class="el" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a> 'owns' this <a class="el" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a> and will be responsible for deleting it. </dd></dl>

</div>
</div><p>
<a class="anchor" name="6d15ea1ce9f9249484b178bb209b2b95"></a><!-- doxytag: member="Ogre::ConvexBody::insertPolygon" ref="6d15ea1ce9f9249484b178bb209b2b95" args="(Polygon *pdata)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::insertPolygon           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *&nbsp;</td>
          <td class="paramname"> <em>pdata</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Inserts a polygon at the end. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>After this method is called, the <a class="el" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a> 'owns' this <a class="el" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a> and will be responsible for deleting it. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9d5648f1dd2ab1dd9c85b1581029983e"></a><!-- doxytag: member="Ogre::ConvexBody::insertVertex" ref="9d5648f1dd2ab1dd9c85b1581029983e" args="(size_t poly, const Vector3 &amp;vdata, size_t vertex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::insertVertex           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vdata</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertex</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Inserts a vertex for a polygon at a particular point. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>No checks are done whether the assembled polygon is (still) planar, the caller must ensure that this is the case. </dd></dl>

</div>
</div><p>
<a class="anchor" name="1e4e72b739b38002b714bcbb63813a7d"></a><!-- doxytag: member="Ogre::ConvexBody::insertVertex" ref="1e4e72b739b38002b714bcbb63813a7d" args="(size_t poly, const Vector3 &amp;vdata)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::insertVertex           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vdata</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Inserts a vertex for a polygon at the end. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>No checks are done whether the assembled polygon is (still) planar, the caller must ensure that this is the case. </dd></dl>

</div>
</div><p>
<a class="anchor" name="96f5b0fff03173772d7e20e5ec74e237"></a><!-- doxytag: member="Ogre::ConvexBody::deletePolygon" ref="96f5b0fff03173772d7e20e5ec74e237" args="(size_t poly)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::deletePolygon           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Deletes a specific polygon. 
<p>

</div>
</div><p>
<a class="anchor" name="bd7e84750f61aed920fb4e847ea29ac9"></a><!-- doxytag: member="Ogre::ConvexBody::unlinkPolygon" ref="bd7e84750f61aed920fb4e847ea29ac9" args="(size_t poly)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Polygon.html">Polygon</a>* Ogre::ConvexBody::unlinkPolygon           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes a specific polygon from the body without deleting it. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>The retrieved polygon needs to be deleted later by the caller. </dd></dl>

</div>
</div><p>
<a class="anchor" name="d139be0d8377d805b0709966974a5cda"></a><!-- doxytag: member="Ogre::ConvexBody::moveDataFromBody" ref="d139be0d8377d805b0709966974a5cda" args="(ConvexBody &amp;body)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::moveDataFromBody           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>body</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Moves all polygons from the parameter body to this instance. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Both the passed in object and this instance are modified </dd></dl>

</div>
</div><p>
<a class="anchor" name="803fa40122153f8772383b7d79ec7e6a"></a><!-- doxytag: member="Ogre::ConvexBody::deleteVertex" ref="803fa40122153f8772383b7d79ec7e6a" args="(size_t poly, size_t vertex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::deleteVertex           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertex</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Deletes a specific vertex of a specific polygon. 
<p>

</div>
</div><p>
<a class="anchor" name="28a76d44fefb5741e2c772533f7b1ed0"></a><!-- doxytag: member="Ogre::ConvexBody::setPolygon" ref="28a76d44fefb5741e2c772533f7b1ed0" args="(Polygon *pdata, size_t poly)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::setPolygon           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Polygon.html">Polygon</a> *&nbsp;</td>
          <td class="paramname"> <em>pdata</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Replace a polygon at a particular index. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Again, the passed in polygon is owned by this object after this call returns, and this object is resonsible for deleting it. </dd></dl>

</div>
</div><p>
<a class="anchor" name="115357323021c86327c0aa8a26b2404f"></a><!-- doxytag: member="Ogre::ConvexBody::setVertex" ref="115357323021c86327c0aa8a26b2404f" args="(size_t poly, const Vector3 &amp;vdata, size_t vertex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::setVertex           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vdata</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>vertex</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Replace a specific vertex of a polygon. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>No checks are done whether the assembled polygon is (still) planar, the caller must ensure that this is the case. </dd></dl>

</div>
</div><p>
<a class="anchor" name="fb0f28d2bc33d000f2b924b3ff287984"></a><!-- doxytag: member="Ogre::ConvexBody::getSingleEdges" ref="fb0f28d2bc33d000f2b924b3ff287984" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">Polygon::EdgeMap</a> Ogre::ConvexBody::getSingleEdges           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the single edges in an EdgeMap (= edges where one side is a vertex and the other is empty space (a hole in the body)). 
<p>

</div>
</div><p>
<a class="anchor" name="4bd6ead8c709b50e3ae96e6c518b50cc"></a><!-- doxytag: member="Ogre::ConvexBody::storeEdgesOfPolygon" ref="4bd6ead8c709b50e3ae96e6c518b50cc" args="(size_t poly, Polygon::EdgeMap *edgeMap) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::storeEdgesOfPolygon           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>poly</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">Polygon::EdgeMap</a> *&nbsp;</td>
          <td class="paramname"> <em>edgeMap</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Stores the edges of a specific polygon in a passed in structure. 
<p>

</div>
</div><p>
<a class="anchor" name="712d479b37a37cf294f249b942546293"></a><!-- doxytag: member="Ogre::ConvexBody::allocateSpace" ref="712d479b37a37cf294f249b942546293" args="(size_t numPolygons, size_t numVertices)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::ConvexBody::allocateSpace           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numPolygons</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numVertices</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Allocates space for an specified amount of polygons with each of them having a specified number of vertices. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Old data (if available) will be erased. </dd></dl>

</div>
</div><p>
<a class="anchor" name="d9638a611986e5d9fbafacd777bb7bd3"></a><!-- doxytag: member="Ogre::ConvexBody::findAndEraseEdgePair" ref="d9638a611986e5d9fbafacd777bb7bd3" args="(const Vector3 &amp;vec, Polygon::EdgeMap &amp;intersectionEdges, Vector3 &amp;vNext) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::ConvexBody::findAndEraseEdgePair           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Polygon.html#75ad4cca62e4f65b7f6007ee29c42644">Polygon::EdgeMap</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>intersectionEdges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vNext</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Searches for a pair (an edge) in the intersectionList with an entry that equals vec, and removes it from the passed in list. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>vec</em>&nbsp;</td><td>The vertex to search for in intersectionEdges </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>intersectionEdges</em>&nbsp;</td><td>A list of edges, which is updated if a match is found </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>vNext</em>&nbsp;</td><td>A reference to a vector which will be filled with the other vertex at the matching edge, if found. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>True if a match was found </dd></dl>

</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="1082989fe2c9773d3e2385dec3f7f694"></a><!-- doxytag: member="Ogre::ConvexBody::operator&lt;&lt;" ref="1082989fe2c9773d3e2385dec3f7f694" args="(std::ostream &amp;strm, const ConvexBody &amp;body)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">_OgreExport friend std::ostream&amp; operator&lt;&lt;           </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&nbsp;</td>
          <td class="paramname"> <em>strm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>body</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Prints out the body with all its polygons. 
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="4a9287e8e6a68839a451150959b1cd95"></a><!-- doxytag: member="Ogre::ConvexBody::mPolygons" ref="4a9287e8e6a68839a451150959b1cd95" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ConvexBody.html#4a13eb065fe856b0354d523394e9dfaa">PolygonList</a> <a class="el" href="classOgre_1_1ConvexBody.html#4a9287e8e6a68839a451150959b1cd95">Ogre::ConvexBody::mPolygons</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreConvexBody_8h-source.html#l00052">52</a> of file <a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8f45e2762a61cfa1ce2cf11fbc8cb6a9"></a><!-- doxytag: member="Ogre::ConvexBody::msFreePolygons" ref="8f45e2762a61cfa1ce2cf11fbc8cb6a9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ConvexBody.html#4a13eb065fe856b0354d523394e9dfaa">PolygonList</a> <a class="el" href="classOgre_1_1ConvexBody.html#8f45e2762a61cfa1ce2cf11fbc8cb6a9">Ogre::ConvexBody::msFreePolygons</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreConvexBody_8h-source.html#l00055">55</a> of file <a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreConvexBody_8h-source.html">OgreConvexBody.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:29 2008
</p>
</body>
</html>
